'use strict';

var Ve = require('crypto');
var Le = require('fs');
var path = require('path');
var promises = require('fs/promises');
var lo = require('tty');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var Ve__default = /*#__PURE__*/_interopDefault(Ve);
var Le__default = /*#__PURE__*/_interopDefault(Le);
var lo__default = /*#__PURE__*/_interopDefault(lo);

function Ln(){if(typeof self<"u")return self;if(typeof window<"u")return window;if(typeof global<"u")return global;if(typeof globalThis<"u")return globalThis;throw new Error("unable to locate global object")}function re(){let e=Ln();return e._zeedGlobal==null&&(e._zeedGlobal={}),e._zeedGlobal}function vn(e){return e===!0||e==="true"||e==="1"||typeof e=="number"&&e!==0?e="*":e===!1||e==="false"||e===0||e==="0"||e==null||e==="null"||e==="undefined"?e="":e=String(e),e}var An=vn(typeof process<"u"?process.env.ZEED??process.env.DEBUG:typeof localStorage<"u"?localStorage.zeed??localStorage.debug:"*");function O(e=An){let t,n=[],r=[];if(!e)t=function(o){return !1};else if(e==="*")t=function(o){return !0};else {let o,i=e.split(/[\s,]+/),a=i.length;for(o=0;o<a;o++){if(!i[o])continue;let s=i[o].replace(/\*/g,".*?");s[0]==="-"?n.push(new RegExp(`^${s.substr(1)}$`)):r.push(new RegExp(`^${s}$`));}t=function(s){if(n.length===0&&r.length===0)return !0;let u,c;for(u=0,c=n.length;u<c;u++)if(n[u].test(s))return !1;for(u=0,c=r.length;u<c;u++)if(r[u].test(s))return !0;return !1};}return t.accept=r,t.reject=n,t.filter=e,t}var En=typeof process<"u"?process.env.ZEED_LEVEL??process.env.LEVEL??process.env.DEBUG_LEVEL:typeof localStorage<"u"?localStorage.zeed_level??localStorage.level??localStorage.debug_level:void 0;function Ae(e){if(e===!1)return 1/0;if(typeof e=="number")return e;if(typeof e=="string"){let t=tt[e.toLocaleLowerCase().trim()];if(t!=null)return t}return -1}function N(e=En){let t=Ae(e);return n=>n>=t}function le(e={}){let{level:t=void 0,filter:n=void 0}=e,r=O(n),o=N(t);return i=>{if(!o(i.level)||!r(i.name))return;let a=i.name?`[${i.name}]`:"";switch(i.level){case 1:console.info(`I|*   ${a}`,...i.messages);break;case 2:console.warn(`W|**  ${a}`,...i.messages);break;case 3:console.error(`E|*** ${a}`,...i.messages);break;default:console.debug(`D|    ${a}`,...i.messages);break}}}var H=(s=>(s[s.all=-1]="all",s[s.debug=0]="debug",s[s.info=1]="info",s[s.warn=2]="warn",s[s.error=3]="error",s[s.fatal=4]="fatal",s[s.off=1/0]="off",s))(H||{}),tt={"*":-1,a:-1,all:-1,d:0,dbg:0,debug:0,i:1,inf:1,info:1,w:2,warn:2,warning:2,e:3,err:3,error:3,fatal:4,off:1/0,"-":1/0};function nt(e=""){let t=[le()],n=u=>!0,r=!1,o=a,i=!1;function a(u="",c){let d=Ae(c??-1);function l(g,m){return d<=g?m:()=>{}}let f=l(0,(...g)=>{p({name:u,messages:g,level:0});});f.label=u,f.extend=function(g){return o(u?`${u}:${g}`:g)};let p=g=>{if(n(u))for(let m of t)m&&m(g);};return f.debug=l(0,(...g)=>{p({name:u,messages:g,level:0});}),f.info=l(1,(...g)=>{p({name:u,messages:g,level:1});}),f.warn=l(2,(...g)=>{p({name:u,messages:g,level:2});}),f.error=l(3,(...g)=>{p({name:u,messages:g,level:3});}),f.fatal=l(4,(...g)=>{throw p({name:u,messages:g,level:4}),new Error(`${g.map(String).join(" ")}`)}),f.assert=l(4,(g,...m)=>{g||f.fatal(...m);}),f}function s(u="",c){let d=o(u,c);return i&&d.debug(`+++ init of logger "${u}" on level "${H[d.level]}".`),d}return s.registerHandler=function(u){t.push(u);},s.setFilter=function(u){n=O(u);},s.setLock=(u=!0)=>r=u,s.setDebug=(u=!0)=>i=u,s.setHandlers=function(u=[]){o!==a&&(o=a),!r&&(t=[...u].filter(c=>typeof c=="function"));},s.level=-1,s.setLogLevel=function(u=-1){r||(s.level=u);},s.setFactory=function(u){r||(o=u);},s}var G;function Ee(){let e=nt();return e.setHandlers([le()]),e}function Pn(){if(G==null)try{let e=re();e!=null?e?.logger==null?(G=Ee(),e.logger=G):G=e.logger:G=Ee();}catch{G=Ee();}return G}var w=Pn();var rt=(e,t)=>t instanceof Object&&!Array.isArray(t)?Object.keys(t).sort().reduce((n,r)=>(n[r]=t[r],n),{}):t;function Uo(e,t=void 0){return JSON.stringify(e,rt,t)}function Sn(e,t){let n=[],r=[];return t==null&&(t=function(o,i){return n[0]===i?"[Circular ~]":`[Circular ~.${r.slice(0,n.indexOf(i)).join(".")}]`}),function(o,i){if(n.length>0){let a=n.indexOf(this);~a?n.splice(a+1):n.push(this),~a?r.splice(a,1/0,o):r.push(o),~n.indexOf(i)&&(i=t?.call(this,o,i));}else n.push(i);i=rt(o,i);try{return e==null?i:e.call(this,o,i)}catch{}return String(i)}}function M(e,t,n,r){return JSON.stringify(e,Sn(t,r),n)}var Ro=M;var ot=w("zeed:bin","error");function Dn(e){let t=unescape(encodeURIComponent(e)),n=t.length,r=new Uint8Array(n);for(let o=0;o<n;o++)r[o]=t.codePointAt(o)||0;return r}function Un(e){let t=e.length,n="",r=0;for(;t>0;){let o=t<1e4?t:1e4,i=e.subarray(r,r+o);r+=o,n+=String.fromCodePoint.apply(null,i),t-=o;}return decodeURIComponent(escape(n))}var fe;function it(e){if(fe==null&&(fe=Dn,typeof TextEncoder<"u")){let t=new TextEncoder;fe=n=>t.encode(n);}return fe(e.normalize("NFC"))}var de;function st(e){if(de==null&&(de=Un,typeof TextDecoder<"u")){let t=new TextDecoder("utf-8",{ignoreBOM:!0});de=n=>t.decode(n);}return de(e).normalize("NFC")}function F(e){return e instanceof ArrayBuffer?new Uint8Array(e):typeof e=="string"?it(e):e.length?new Uint8Array(e):e}function Co(...e){let t=0,n=e.flat(1).map(i=>{let a=F(i);return t+=a.length,a}),r=new Uint8Array(t),o=0;for(let i of n)r.set(i,o),o+=i.length;return r}function at(e){if(typeof Buffer<"u")return Buffer.from(F(e)).toString("hex");let t="0123456789abcdef",n="";for(let r of [...F(e)])n+=t[r>>4]+t[r&15];return n}function ut(e){return Uint8Array.from(e.match(/.{1,2}/g).map(t=>parseInt(t,16)))}function ct(e,t=!1){let n=F(e),r="";if(typeof Buffer<"u")r=Buffer.from(n).toString("base64");else {let o="";for(let i=0;i<n.byteLength;i++)o+=String.fromCharCode(n[i]);r=btoa(o);}return t?r.replaceAll("=",""):r}function $o(e){let t=F(e);if(typeof Buffer<"u")return Buffer.from(t).toString("base64url").replaceAll("=","");let n="";for(let r=0;r<t.byteLength;r++)n+=String.fromCharCode(t[r]);return btoa(n).replaceAll("+","-").replaceAll("/","_").replaceAll("=","")}function Rn(e){if(e=e.replaceAll("-","+").replaceAll("_","/"),typeof Buffer<"u"){let r=Buffer.from(e,"base64");return new Uint8Array(r.buffer,r.byteOffset,r.byteLength)}let t=atob(e),n=new Uint8Array(t.length);for(let r=0;r<t.length;r++)n[r]=t.charCodeAt(r);return n}function Io(e){return st(Rn(e))}function lt(e,t){if(e.byteLength!==t.byteLength)return !1;let n=F(e),r=F(t);for(let o=0;o<n.length;o++)if(n[o]!==r[o])return !1;return !0}function Pe(e){try{return it(M(e))}catch(t){throw ot.warn("jsonToUint8Array",e),t}}function Se(e){try{return JSON.parse(st(e))}catch(t){throw ot.warn("Uint8ArrayToJson",e),t}}function ft(e,t){if(typeof e!="string")if(e instanceof ArrayBuffer&&e.byteLength!==void 0)e=String.fromCharCode.apply(String,[].slice.call(new Uint8Array(e)));else if(Array.isArray(e))e=String.fromCharCode.apply(String,e);else if(e.constructor===Uint8Array)e=String.fromCharCode.apply(String,[].slice.call(e));else return !1;t=t||16;let n=[],r="0123456789ABCDEF";for(let o=0;o<e.length;o+=t){let i=e.slice(o,Math.min(o+t,e.length)),a=`0000${o.toString(16)}`.slice(-4),s=i.split("").map(c=>{let d=c.charCodeAt(0);return ` ${r[(240&d)>>4]}${r[15&d]}`}).join("");s+="   ".repeat(t-i.length);let u=i.replace(/[\x00-\x1F\x20]/g,".");u+=" ".repeat(t-i.length),n.push(`${a} ${s}  ${u}`);}return n.join(`
`)}function Z(e=16){let t=new Uint8Array(e);if(typeof crypto<"u"&&crypto.getRandomValues)crypto.getRandomValues(t);else for(let n=0;n<e;n++)t[n]=Math.floor(Math.random()*256);return t}var pt="SHA-256",De="AES-GCM",dt="PBKDF2",Mn=1e5;async function _o(e,t=pt){return F(await crypto.subtle.digest(t,F(e)))}async function jo(e,t={}){let n=F(e),r=await crypto.subtle.importKey("raw",n,dt,!1,["deriveKey"]);return await crypto.subtle.deriveKey({name:dt,salt:t.salt?F(t.salt):new Uint8Array(0),iterations:t.iterations??Mn,hash:pt},r,{name:De,length:256},!0,["encrypt","decrypt"])}var pe=new Uint8Array([1,1]);async function gt(e,t){let n=Z(12),r=await crypto.subtle.encrypt({name:De,iv:n},t,e),o=new Uint8Array(r),i=pe.length+n.length+o.length,a=new Uint8Array(i),s=0;return a.set(pe,s),s+=pe.length,a.set(n,s),s+=n.length,a.set(o,s),a}async function mt(e,t){let n=e.subarray(0,2);if(!lt(n,pe))return Promise.reject(new Error(`Unknown magic ${n}`));let r=e.subarray(2,2+12),o=e.subarray(2+12,e.length),i=await crypto.subtle.decrypt({name:De,iv:r},t,o);return new Uint8Array(i)}function Fn(){return crypto.getRandomValues(new Uint32Array(1))[0]/4294967295}function U(){return typeof crypto<"u"?Fn():Math.random()}function Ho(e=.25){return U()<e}function zo(e=100,t=0){return t+Math.floor(U()*(e-t))}function Go(e=100,t=0){return t+U()*(e-t)}function Vo(e,t,n){return Math.max(e,Math.min(n,t))}function kn(e){return e.reduce((t,n)=>t+n,0)}function qo(e){return kn(e)/e.length}function Wo(e){return !/^1?$|^(11+?)\1+$/.test("1".repeat(e))}function Jo(e){for(let t=2;t<e;t++)if(e%t===0)return !1;return e>1}var Ue=6;function Zo(e=0,t=1,n){Ue=((n??Ue)*9301+49297)%233280;let r=Ue/233280;return t+r*(e-t)}function Cn(e=""){let[t="",n="asc"]=e.split(" ");return n=n.toLowerCase(),{field:t,orderby:n,asc:n!=="desc",desc:n==="desc"}}function Yo(e,t=!0){return `${e} ${t?"asc":"desc"}`}function Re(e,t,n=!0){let r=e||0,o=t||0;return r>o?n?1:-1:r<o?n?-1:1:0}function Qo(e,...t){if(t.length>0){let n=t.map(Cn),r=Array.from(e);return r.sort((o,i)=>{for(let{field:a,asc:s}of n){let u=Re(o[a],i[a],s);if(u!==0)return u}return 0}),r}return e}function Me(e){return e.filter((t,n)=>e.indexOf(t)===n)}function $n(e,t){return Me(e.filter(n=>!t.includes(n)))}function In(...e){return Me(e.reduce((t=[],n)=>t.concat(n),[]))}function K(...e){return e.flat(1/0)}function On(e,t){return Me(e).filter(n=>t.includes(n))}function ni(e,t){return $n(In(e,t),On(e,t))}function yt(e,t){if(e&&Array.isArray(e)){let n;for(;(n=e.indexOf(t))!==-1;)e.splice(n,1);return e}return []}function ri(e,t){return e.includes(t)||e.push(t),e}function Fe(e,t){return e.splice(0,e.length,...e.filter(t)),e}function oi(e,t){let n=e.findIndex(r=>r===t);return n>=0?e.splice(n,1):e.push(t),e}function ii(e){return e.splice(0,e.length),e}function Bn(e,t=Re){return Array.from(e).sort(t)}function si(e){return Bn(e,(t,n)=>t-n)}function _n(e,t){return e.length===t.length&&e.every((n,r)=>n===t[r])}function ht(e){return e.sort(()=>U()>.5?1:-1),e}function ai(e){return ht(Array.from(e))}function ui(e){for(;e.length>1;){let t=Array.from(e);if(ht(t),!_n(e,t))return t}return e}function ci(e){return e[Math.floor(U()*e.length)]}function li(...e){return K(e).reduce((t,n)=>t!=null?n>t?n:t:n,void 0)}function fi(...e){return K(e).reduce((t,n)=>t!=null?n<t?n:t:n,void 0)}function di(...e){return K(e).reduce((t,n)=>t+n,0)}function pi(...e){let t=K(e);return t.reduce((n,r)=>n+r,0)/t.length}function gi(e,t){let n=[],r=0,o=e.length;for(;r<o;)n.push(e.slice(r,r+=t));return n}function mi(e=0,t){if(e<=0)return [];let n=new Array(e);for(let r=0;r<e;r++)n[r]=t instanceof Function?t(r):t;return n}var jn=w("zeed:basex","error"),Nn={2:"01",8:"01234567",11:"0123456789a",16:"0123456789abcdef",32:"0123456789abcdefghjkmnpqrtuvwxyz","32-crockford":"0123456789ABCDEFGHJKMNPQRSTVWXYZ","32-geohash":"0123456789bcdefghjkmnpqrstuvwxyz","32-agnoster":"0123456789abcdefghjkmnpqrtuvwxyz","32-rfc":"ABCDEFGHIJKLMNOPQRSTUVWXYZ234567","32-hex":"0123456789ABCDEFGHIJKLMNOPQRSTUV","32-zbase":"ybndrfg8ejkmcpqxot1uwisza345h769",36:"0123456789abcdefghijklmnopqrstuvwxyz",58:"123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz",62:"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz",64:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/","64-url":"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_",66:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.!~",85:"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!#$%&()*+-;<=>?@^_`{|}~"};function V(e){let t=Nn[String(e)];if(!t)if(typeof e=="string")t=e;else throw new Error(`Unknown base ${e}`);if(t.length>=255)throw new TypeError("Alphabet too long");let n=new Uint8Array(256);for(let c=0;c<n.length;c++)n[c]=255;for(let c=0;c<t.length;c++){let d=t.charAt(c),l=d.charCodeAt(0);if(n[l]!==255)throw new TypeError(`${d} is ambiguous`);n[l]=c;}let r=t.length,o=t.charAt(0),i=Math.log(r)/Math.log(256),a=Math.log(256)/Math.log(r);function s(c,d=-1){let l=F(c);if(l.byteLength===0)return "";let f=0,p=0,g=l.byteLength;for(;p!==g&&l[p]===0;)p++;let m=(g-p)*a+1>>>0,b=new Uint8Array(m);for(;p!==g;){let E=l[p],S=0;for(let h=m-1;(E!==0||S<f)&&h!==-1;h--,S++)E+=256*b[h]>>>0,b[h]=E%r>>>0,E=E/r>>>0;if(E!==0)throw jn.warn("Non-zero carry",l,d,S,m),new Error("Non-zero carry");f=S,p++;}let y=m-f;for(;y!==m&&b[y]===0;)y++;let L="";for(;y<m;++y)L+=t.charAt(b[y]);return d>0?L.padStart(d,o):L}function u(c,d=-1){if(typeof c!="string")throw new TypeError("Expected String");if(c.length===0)return new Uint8Array;c=c.replace(/\s+/gi,"");let l=0,f=0;for(;c[l]===o;)l++;let p=(c.length-l)*i+1>>>0,g=new Uint8Array(p);for(;c[l];){let b=n[c.charCodeAt(l)];if(b===255)throw new Error(`Unsupported character "${c[l]}"`);let y=0;for(let L=p-1;(b!==0||y<f)&&L!==-1;L--,y++)b+=r*g[L]>>>0,g[L]=b%256>>>0,b=b/256>>>0;if(b!==0)throw new Error("Non-zero carry");f=y,l++;}let m=p-f;for(;m!==p&&g[m]===0;)m++;return d>0?new Uint8Array([...new Uint8Array(d-g.length+m),...g.slice(m)]):g.slice(m)}return {encode:s,decode:u}}var {encode:bi,decode:Hn}=V(32);function Ti(e){return Hn(e.toLocaleLowerCase().replaceAll("l","1").replaceAll("s","5").replaceAll("o","0").replaceAll("i","1"))}var {encode:wi,decode:Li}=V(16),{encode:vi,decode:Ai}=V(58),{encode:Ei,decode:Pi}=V(62);function Si(e,t){return Math.ceil(e*(Math.log(256)/Math.log(t)))}var xt=e=>(e.length>0&&(/^[A-Z0-9_\-\ ]*$/g.test(e)&&(e=e.toLowerCase()),e=e.replace(/^[-_\ ]+/gi,"").replace(/[-_\ ]+$/gi,"").replace(/[-_\ ]+([a-z0-9])/gi,(t,n)=>n.toUpperCase()),e=e[0].toLowerCase()+e.substring(1)),e);function zn(e){return e.charAt(0).toUpperCase()+e.toLowerCase().slice(1)}function Ui(e){return e.replace(/\w\S*/g,zn)}function Ri(e,t="-"){return t=typeof t>"u"?"_":t,e.replace(/([a-z\d])([A-Z])/g,`$1${t}$2`).replace(/([A-Z]+)([A-Z][a-z\d]+)/g,`$1${t}$2`).toLowerCase()}var bt=["1","true","yes","y","on"];function ki(e,t=!1){return e==null||typeof e!="string"?t:bt.includes(String(e).trim().toLowerCase())}function Ci(e,t=0){return e==null||typeof e!="string"?t:parseInt(e.trim(),10)??t}function $i(e,t=0){return e==null||typeof e!="string"?t:parseFloat(e.trim())??t}function Y(e,t=!1){return e==null?t:typeof e=="boolean"?e:typeof e=="number"?e!==0:bt.includes(String(e).trim().toLowerCase())}function Gn(e,t=0){return e==null?t:typeof e=="boolean"?e?1:0:typeof e=="number"?Math.floor(e):parseInt(String(e).trim(),10)??t}function Vn(e,t=0){return e==null?t:typeof e=="boolean"?e?1:0:typeof e=="number"?Math.floor(e):parseFloat(String(e).trim())??t}function ke(e,t=""){return e==null?t:String(e)??t}var Ii=Vn,Oi=Gn,Bi=ke,_i=Y;function qn(e,t={}){let{trace:n=!0,pretty:r=!0}=t;return e.map(o=>{if(o&&typeof o=="object"){if(r&&(o instanceof Uint8Array||o instanceof ArrayBuffer))return `
${ft(o)}
`;if(o instanceof Error)return n?`${o.name||"Error"}: ${o.message}
${o.stack}`:`${o.name||"Error"}: ${o.message}`;try{return r?JSON.stringify(o,null,2):JSON.stringify(o)}catch{}}return String(o)})}function ge(e,t={}){return qn(e,t).join(" ")}function ji(e){try{return decodeURIComponent(escape(e))}catch{}return e}var $e=864e5;function Ie(e){return Math.floor(e/1e4)}function Tt(e){return Math.floor(e/100%100)}function Wn(e){return Math.floor(e%100)}function Hi(e){return [Ie(e),Tt(e),Wn(e)]}function wt(e,t=!1){return t?new Date(`${Zn(e)}T00:00:00.000Z`):new Date(e/1e4,e/100%100-1,e%100)}function Lt(){return ye(new Date)}function zi(e,t=!1){if(typeof e=="number")return e<100?void 0:e;if(typeof e=="string")return vt(e);if(Array.isArray(e)&&e.length===3){let[n,r,o]=e;return Oe(n,r,o)}else if(e instanceof Date)return ye(e,t)}function Gi(e){return wt(e,!0)}function ye(e,t=!1){return t?vt(e.toISOString()):e.getFullYear()*1e4+(e.getMonth()+1)*100+e.getDate()}function Vi(e){return ye(e,!0)}function Ce(e,t=!0){return wt(e,t).getTime()}function Jn(e,t=!0){return ye(new Date(e),t)}function Zn(e,t="-"){let n=String(e);return n.slice(0,4)+t+n.slice(4,6)+t+n.slice(6,8)}function Oe(e,t=1,n=1){if(!(t<1||t>12||n<1||n>31))return e*1e4+t*100+n}function vt(e){let t=String(e).replace(/[^0-9]/g,"").slice(0,8);if(t.length===8)return +t}function qi(e,t=0){let n=Ie(e),r=Tt(e);return t!==0&&(r+=t,n+=Math.floor((r-1)/12),r=Math.floor((r-1)%12)+1,r===0&&(r=12)),Oe(n,r,1)}function Wi(e,t=0){let n=Ie(e);return Oe(n+t,1,1)}function me(e,t){return Jn(Ce(e)+t*864e5)}function Ji(e,t){return Math.round((Ce(t)-Ce(e))/864e5)}function Zi(e,t){let n=[];for(t==null&&(t=Lt()),e<0&&(e=me(t,e+1));e<=t;)n.push(e),e=me(e,1);return n}function*Ki(e,t){let n=[];for(t==null&&(t=Lt()),e<0&&(e=me(t,e+1));e<=t;)yield e,e=me(e,1);return n}var At=w("zeed:promise","error");function Et(){let e,t;return [new Promise((r,o)=>{e=r,t=o;}),e,t]}async function Xi(e){return new Promise(t=>setTimeout(t,e))}async function es(){return new Promise(e=>setTimeout(e,0))}var Pt=Symbol("timeout");async function ts(e,t,n=Pt){return new Promise(async(r,o)=>{let i=!1,a=setTimeout(()=>{i=!0,r(n);},t);try{let s=await e;clearTimeout(a),i||r(s);}catch(s){clearTimeout(a),i||o(s);}})}var St=new Error("Timeout reached");function ns(e){return e===Pt||e===St}async function Dt(e,t){return t<=0?await e:new Promise(async(n,r)=>{let o=!1,i=setTimeout(()=>{o=!0,r(St);},t);try{let a=await e;clearTimeout(i),o||n(a);}catch(a){clearTimeout(i),o||r(a);}})}function rs(e,t,n=1e3){return new Promise((r,o)=>{let i=u=>{s&&(clearTimeout(s),a(),r(u));},a=()=>{s=null,e.off?e.off(t,i):e.removeEventListener?e.removeEventListener(t,i):At.warn("No remove listener method found for",e,t);},s=setTimeout(()=>{a(),o(new Error("Did not response in time"));},n);e.on?e.on(t,i):e.addEventListener?e.addEventListener(t,i):At.warn("No listener method found for",e);})}function C(e){return !!(e&&(e instanceof Promise||typeof e.then=="function"))}function B(e){return Promise.resolve(e)}var A=class{get value(){return this.days}constructor(t){if(typeof t=="number"){this.days=t;return}if(t!=null&&(t=A.from(t)?.days),t==null){let n=new Date;this.days=n.getFullYear()*1e4+(n.getMonth()+1)*100+n.getDate();}else this.days=t;}static fromNumber(t){return new A(t)}static fromString(t){return A.from(+t.replace(/[^0-9]/g,"").slice(0,8))}static fromDate(t,n=!1){return n?A.fromString(t.toISOString().substr(0,10)):A.from(t.getFullYear()*1e4+(t.getMonth()+1)*100+t.getDate())}static fromDateGMT(t){return A.fromDate(t,!0)}static from(t,n=!1){if(typeof t=="number")return t<100?void 0:new A(t);if(typeof t=="string")return A.fromString(t);if(Array.isArray(t)&&t.length===3){let[r,o=1,i=1]=t;return o<1||o>12||i<1||i>31?void 0:new A(r*1e4+o*100+i)}else {if(t instanceof Date)return A.fromDate(t,n);if(t instanceof A)return t}}toNumber(){return this.days}toJson(){return this.days}toString(t="-"){let n=String(this.days);return n.slice(0,4)+t+n.slice(4,6)+t+n.slice(6,8)}toDate(t=!1){return t?new Date(`${this.toString()}T00:00:00.000Z`):new Date(this.days/1e4,this.days/100%100-1,this.days%100)}toDateGMT(){return this.toDate(!0)}get year(){return Math.floor(this.days/1e4)}get month(){return Math.floor(this.days/100%100)}get day(){return Math.floor(this.days%100)}dayOffset(t){return A.fromDateGMT(new Date(this.toDateGMT().getTime()+t*864e5))}monthStart(){return A.from([this.year,this.month,1])}yearStart(){return A.from([this.year,1,1])}monthOffset(t){let n=this.month+t,r=Math.floor((n-1)%12)+1;r===0&&(r=12);let o=Math.floor((n-1)/12);return A.from([this.year+o,r,this.day])}daysUntil(t){return Math.round((new A(t)?.toDateGMT().getTime()-this.toDateGMT().getTime())/864e5)}yesterday(){return this.dayOffset(-1)}tomorrow(){return this.dayOffset(1)}};async function as(e,t,n){let r=A.from(e),o=A.from(t);for(;r&&o&&r?.days<=o?.days;){let i=n(r);C(i)&&await i,r=r.dayOffset(1);}}function us(){return new A}function cs(e){return new A(e)}function ls(e){return A.fromDate(new Date(e)).days}function Kn(e,t=2){return +(+e).toFixed(t)}function ds(e,t=2){return +(+e/10**t).toFixed(t)}function ps(e,t=2){return Math.round(+e*10**t)}function gs(e,t=2){return t*(Kn(e,t)%1)}function _(e){return e!=null&&typeof e=="object"}function Be(e){return Object(e)!==e}function j(e){return Array.isArray(e)}function he(e){return _(e)&&!j(e)}function ys(e){return e?.constructor===Object}function Ut(e){return typeof e=="string"}function Rt(e){return typeof e=="number"&&!isNaN(e)}function hs(e){return Rt(e)&&Number.isInteger(e)}function xs(e){return Rt(e)&&Number.isSafeInteger(e)}function Mt(e){return typeof e=="boolean"}function bs(e){return e==null}function Ts(e){return e==null}function ws(e){return _(e)&&e.constructor.name==="Uint8Array"}function Ft(e){return e!=null}function Ls(e){return e!=null&&e!==!1&&e!==!0}function Yn(e,t,n=new WeakSet){if(e===t)return !0;if(n.has(t)||(Be(t)||n.add(t),!(e instanceof Object)||!(t instanceof Object))||e.constructor!==t.constructor||e.length!==t.length)return !1;for(let r in e){if(!e.hasOwnProperty(r))continue;if(!t.hasOwnProperty(r))return !1;let o=e[r],i=t[r];if(!Yn(o,i,n))return !1}for(let r in t)if(t.hasOwnProperty(r)&&!e.hasOwnProperty(r))return !1;return !0}function Qn(e,t=new WeakSet){if(t.has(e))return "[Circular ~]";if(Be(e)||t.add(e),he(e)){for(let n in e)if(e.hasOwnProperty(n)){if(e[n]===void 0){delete e[n];continue}Qn(e[n],t);}}else if(j(e))for(let n=e.length-1;n>=0;n--)e[n]===void 0&&e.splice(n,1);return e}function xe(e,...t){for(let n of t)_(e)||(e={}),!(n==null||!_(n))&&Object.keys(n).forEach(r=>{let o=e[r],i=n[r];Array.isArray(o)&&Array.isArray(i)?e[r]=o.concat(i):_(o)&&_(i)?e[r]=xe(Object.assign({},o),i):e[r]=i;});return e}var kt=e=>e.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/'/g,"&apos;").replace(/"/g,"&quot;"),Ps=e=>e.replace(/&lt;/gi,"<").replace(/&gt;/gi,">").replace(/&quot;/gi,'"').replace(/&apos;/gi,"'").replace(/&amp;/gi,"&");function Ds(e,t,n=[]){return e.filter(r=>!t.some(o=>!o(r))).map(r=>{for(let o of n)r=o(r);return r}).filter(r=>r!=null)}function Us(e,t){return e.reduce((n,r)=>{let o=String(r[t]);return (n[o]=n[o]||[]).push(r),n},{})}function Rs(e,t){return Array.from(e.reduce((n,r)=>n.add(r[t]),new Set))}function Ms(e,t){return e.map(n=>n[t])}function Cs(e,t){return _(e)?Object.fromEntries(Object.entries(e).map(([n,r])=>{let o=t(n,r);return j(o)&&o.length===2?o:[n,o]}).filter(n=>n!=null)):{}}function $s(e,t){return t.dispose&&e.dispose&&t.dispose.add(e.dispose),Object.assign(e,t)}function Is(e){return Object.keys(e).length<=0}var Ct=/[\u0000-\u001F\u0080-\u009F]/g,Xn=/^\.+/,er=/\.+$/;function $t(){return /[<>:"/\\|?*\u0000-\u001F]/g}function tr(){return /^(con|prn|aux|nul|com\d|lpt\d)$/i}function It(e,t="_"){if(typeof e!="string")throw new TypeError("Expected a string");if($t().test(t)&&Ct.test(t))throw new Error("Replacement string cannot contain reserved filename characters");return e=e.replace($t(),t).replace(Ct,t).replace(Xn,t).replace(er,""),e=tr().test(e)?e+t:e,e.slice(0,100)}var nr=/[\\\-\[\]\/{}()*+?.^$|]/g;function Ot(e){return e?e instanceof RegExp?e.source:e.replace(nr,"\\$&"):""}var oe=e=>Math.abs(e)%1===.5,Bt=e=>e%2===0,js=e=>Math.ceil(e),Ns=e=>Math.floor(e),Hs=e=>Math.round(e),zs=e=>{let t=Math.round(e);return oe(e)&&Bt(t)?t-1:t},Gs=e=>oe(e)?Math.sign(e)*Math.ceil(Math.abs(e)):Math.round(e),Vs=e=>oe(e)?Math.floor(e):Math.round(e),qs=e=>{let t=Math.round(e);return oe(e)?Bt(t)?t:t-1:t},Ws=e=>oe(e)?Math.sign(e)*Math.floor(Math.abs(e)):Math.round(e);function _t(e){return e.reduce((t,n)=>Math.min(t,n.sort_weight||0),0)-1-U()}function jt(e){return e.reduce((t,n)=>Math.max(t,n.sort_weight||0),0)+1+U()}function Ks(e,t,n){let r=n.length,o=e<t;if(r<=0||e>=r-1)return jt(n);if(e<=0)return _t(n);n=rr([...n]);let i=o?-1:0,a=n[e+i].sort_weight||0,u=(n[e+i+1].sort_weight||0)-a;if(u===0)return o?_t(n):jt(n);let c=a+u/2,d=u*.01*(U()-.5);return c+d}function rr(e){return e.sort((t,n)=>(t.sort_weight||0)-(n.sort_weight||0)),e}function Xs(e={}){let{getter:t=s=>s.sort}=e;function n(s){return s.sort((u,c)=>(t(u)||0)-(t(c)||0)),s}function r(s){return s.reduce((u,c)=>Math.min(u,t(c)||0),0)-1-U()}function o(s){return s.reduce((u,c)=>Math.max(u,t(c)||0),0)+1+U()}function i(s,u){s==null&&(s=(u??0)-1),u==null&&(u=(s??0)+1);let c=u-s,d=s+c/2,l=c*.01*(U()-.5);return d+l}function a(s,u,c){let d=c.length,l=s<u;if(d<=0||s>=d-1)return o(c);if(s<=0)return r(c);c=n([...c]);let f=l?-1:0,p=t(c[s+f])||0,m=(t(c[s+f+1])||0)-p;if(m===0)return l?r(c):o(c);let b=p+m/2,y=m*.01*(U()-.5);return b+y}return {start:r,end:o,between:i,move:a,items:n}}var or=/((?:(?:(?:https?|ftp):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z0-9\u00A1-\uFFFF][a-z0-9\u00A1-\uFFFF_-]{0,62})?[a-z0-9\u00A1-\uFFFF]\.)+(?:[a-z\u00A1-\uFFFF]{2,}\.?))(?::\d{2,5})?(?:[/?#]\S*)?)/gim;function na(e){return e.split(or).map((t,n)=>{let r=kt(t);return n%2?`<a target="_blank" href="${r}">${ir(r)}</a>`:r}).join("")}function ir(e){return e.replace(/^https?:\/\/(www\.)?/,"").replace(/\/$/,"")}function Nt(e){let t=[];for(let[n,r]of Object.entries(e))if(r!=null){Array.isArray(r)||(r=[r]);for(let o of r)o!=null&&t.push(`${encodeURIComponent(n)}=${encodeURIComponent(String(o))}`);}return t.join("&")}function ra(e){let t={},n=(e[0]==="?"?e.substr(1):e).split("&");for(let r=0;r<n.length;r++){let o=n[r].split("="),i=decodeURIComponent(o[0]),a=decodeURIComponent(o[1]||"");t[i]!=null?(Array.isArray(t[i])||(t[i]=[t[i]]),t[i].push(a)):t[i]=a;}return t}function sa(e,t,n){let r=e[t];return r===void 0&&(r=n(t,e),e[t]=r),r}async function aa(e,t,n){let r=e[t];return r===void 0&&(r=await n(t,e),e[t]=r),r}function ua(e){return e!=null?e.size!=null?e.size:e.length!=null?e.length:Object.keys(e).length:0}function ca(e){return e!=null&&e.length>0?e[e.length-1]:void 0}function la(e){try{if(e!=null)return Array.isArray(e)||typeof e=="string"?e.length<=0:e?.size!=null?e.size<=0:Object.keys(e).length<=0}catch(t){console.warn("Failed to check if empty for",e,t);}return !0}function Q(e){return Object(e)!==e?e:JSON.parse(M(e))}function fa(e){return Object(e)!==e?e:JSON.parse(M(e))}function da(e){let t=new Map;return n=>{if(t.has(n))return t.get(n);let r=e(n);return t.set(n,r),r}}function pa(e){let t=new Map;return async(...n)=>{let r=M(n);if(t.has(r))return t.get(r);let o=await e(...n);return t.set(r,o),o}}function ga(e,t){let n=[];for(let r=0;r<e;r++)n.push(t(r,e));return n}var sr=/\\\s|\s+|#[^\n]*\n?/gm,ar=/\(\?P?<(\w[\w\d_]+)>|\((?!\?(:|\!|=|<=|<\!))/gm,Ht=/^((?:\(\?[\w$]+\))?)\(\?<([=!])([\s\S]*?)\)/gm,ur=w("zeed:xrx","error");function cr(e){return typeof e=="string"?e:e.source||""}function ha(e){return e.replace(/[-\[\]{}()*+?.,\\^$|#\s]/g,"\\$&")}var zt=class{constructor(t,n){this.namedGroups={};this.names=[];let r=n??"",o;if(t instanceof RegExp?(n==null&&(r=t.flags),o=t.source):o=t,r&&r.includes("x")&&(r=r.replace("x",""),o=o.replace(sr,s=>s[0]==="\\"?s:"")),!(t instanceof RegExp)){let s=0;o=o.replace(ar,(u,c)=>(s+=1,c?(c!=="index"&&c!=="length"&&!this.namedGroups[c]?this.namedGroups[c]=s:ur.error(`Unallowed or duplicate group name: ${c}`),"("):u)),this.names=Object.keys(this.namedGroups);}o=cr(o),Ht.lastIndex=0;let a=Ht.exec(o);a&&(this.lookBehind={rx:new RegExp(`${a[3]}$(?!\\s)`),expect:a?a[2]==="=":!a},o=o.substr(a[0].length)),this.rx=new RegExp(o,r);}get lastIndex(){return this.rx.lastIndex}set lastIndex(t){this.rx.lastIndex=t;}_handleMatch(t){if(this.lookBehind){let n=t.input.slice(0,t.index);if(this.lookBehind.expect!==this.lookBehind.rx.test(n))return null}for(let n of this.names)t[n]=t[this.namedGroups[n]];return t}exec(t){let n;for(;n=this.rx.exec(t);)if(this.rx.lastIndex===n.index&&this.rx.lastIndex++,n=this._handleMatch(n),n!=null)return n}execAll(t){let n=[],r;for(this.rx.lastIndex=0;r=this.exec(t);)n.push(r);return this.rx.lastIndex=0,n}replace(t,n){let r=typeof n=="function"?n:()=>n;return t.replace(this.rx,o=>r(o))}};var lr=",";function Va(e,t={}){let{separator:n=lr}=t,r="";for(let o=0;o<e.length;o++)r+=`${e[o].map(i=>{if(i==null||i==="")return "";if(Mt(i))return i?1:0;let a=String(i);return (he(i)||j(i))&&(a=M(i)),a.includes('"')||a.includes(`
`)||a.includes(n)?`"${a.replace(/"/g,'""')}"`:a}).join(n)}
`;return r}function fr(e,t={}){let n=/("((?:(?:[^"]*?)(?:"")?)*)"|([^,;\t\n]*))([,;\t]|\n|\r\n)/g;t.separator&&(n=new RegExp(n.source.replaceAll(",;\\t",Ot(t.separator)),n.flags));let r=[],o=[],i,a=`${e.replaceAll(`\r
`,`
`).trim()}
`;for(;i=n.exec(a);){let s=i[2]??i[3]??"";s=s.replaceAll('""','"'),o.push(s),i[4]===`
`&&(r.push(o),o=[]);}return r}function qa(e,t={}){let n=fr(e,t),r=n[0];return n.slice(1).map(o=>Object.fromEntries(o.map((i,a)=>[r[a],i])))}var dr=w("zeed:dispose");async function pr(e){typeof e=="function"?await B(e()):C(e)?await e:typeof e.dispose=="function"?await B(e.dispose()):C(e.dispose)?await e.dispose:typeof e.cleanup=="function"?await B(e.cleanup()):C(e.cleanup)&&await e.cleanup;}function ie(e){let t=e;t!=null&&(Ut(t)?t={name:t}:"debug"in t&&"label"in t&&(t={name:t.label,log:t}));let n=t?.name,r=t?.log??dr,o=[],i=async u=>{u!=null&&o.includes(u)&&(Fe(o,c=>c!==u),await pr(u));},a=async()=>{for(n&&r.debug(`dispose "${n}": ${o.length} entries`);o.length>0;)await i(o[0]);},s=u=>{if(u!=null)return o.unshift(u),()=>i(u)};return Object.assign(a,{track:s,add:s,untrack:i,dispose:a,exec:a,getSize(){return o.length},isDisposed(){return o.length<=0}})}var Qa=ie;function Xa(e={}){let{mode:t="fifo"}=e,n=[],r=async(i=!1)=>{for(;n.length>0;){let a=n[0];if(Fe(n,s=>s!==a),typeof a=="function"){let s=a();if(C(s)){if(i)throw new Error(`Expected sync only function, but found async: ${a}`);await s;}}else if(C(a)){if(i)throw new Error(`Expected sync only function, but found async: ${a}`);await a;}else throw new Error(`Unhandled disposable: ${a}`)}};return Object.assign(r,{add:i=>{t==="lifo"?n.unshift(i):n.push(i);},exec:r,getSize(){return n.length}})}function eu(e,t=0){let n=setTimeout(e,t);return ()=>{n&&(clearTimeout(n),n=void 0);}}function tu(e,t){let n=setInterval(e,t);return ()=>{n&&(clearInterval(n),n=void 0);}}function nu(e,t,n,...r){return e==null?()=>{}:(e.on?e.on(t,n,...r):e.addEventListener&&e.addEventListener(t,n,...r),()=>{e.off?e.off(t,n,...r):e.removeEventListener&&e.removeEventListener(t,n,...r);})}function iu(){let e=!0;return (t,n)=>{let r=!1;if(e){e=!1;try{t(),r=!0;}finally{e=!0;}}else n!==void 0&&n();return r}}function su(){let e=!0;return async(t,n)=>{let r=!1;if(e){e=!1;try{let o=t();C(o)&&await o,r=!0;}finally{e=!0;}}else if(n!==void 0){let o=n();C(o)&&await o;}return r}}var X=w("zeed:emitter","error"),k=class{constructor(){this.subscribers={};this.subscribersOnAny=[];this.dispose=ie();this.call=new Proxy({},{get:(t,n)=>async(...r)=>await this.emit(n,...r)});}async emit(t,...n){let r=!1;try{let o=this.subscribers[t]||[];if(this.subscribersOnAny.forEach(i=>i(t,...n)),o.length>0){let i=o.map(a=>{try{return B(a(...n))}catch(s){X.warn("emit warning:",s);}return null}).filter(a=>a!=null);r=!0,await Promise.all(i);}}catch(o){X.error("emit exception",o);}return r}onAny(t){this.subscribersOnAny.push(t);}on(t,n){let r=this.subscribers[t]||[];return r.push(n),this.subscribers[t]=r,()=>{this.off(t,n);}}onCall(t){for(let[n,r]of Object.entries(t))this.on(n,r);}once(t,n){let r=async(...o)=>(this.off(t,r),await B(n(...o)));return this.on(t,r),()=>{this.off(t,n);}}off(t,n){return this.subscribers[t]=(this.subscribers[t]||[]).filter(r=>n&&r!==n),this}removeAllListeners(){return this.subscribers={},this}};function pu(){let e=re().emitter;return e||(e=new k,re().emitter=e),e}var gu=new k;function mu(e,t){let n=Math.round(U()*100),r=[],o,i=(s,u)=>{let c={key:s,obj:u};r.push(c),o&&o();};return t?e.on?e.on(t,s=>{i(t,s);}):e.addEventListener?e.addEventListener(t,s=>{i(t,s);}):X.error(n,"Cannot listen to key"):e.onAny?e.onAny((s,u)=>{i(s,u);}):X.error(n,"cannot listen to all for",e),(s,u=!0)=>new Promise((c,d)=>{s||(s=t,s||r.length&&(s=r[0].key)),o=()=>{for(;r.length>0;){let l=r.shift();if(l.key===s)o=void 0,c(l.obj);else {if(u){X.warn(n,`Unhandled event ${s} with value: ${l.obj}`);continue}d(new Error(`Expected ${s}, but found ${l.key} with value=${l.obj}`)),X.error(n,`Unhandled event ${s} with value: ${l.obj}`);}break}},o();})}var se=()=>Date.now();function Gt(e){return e>999?`${(e/1e3).toFixed(1)}s`:`${e.toFixed(2)}ms`}function hu(...e){for(let t of e){if(t instanceof Date)return t;if(typeof t=="string"){let n=null;if(t.includes(":"))try{n=new Date(t);}catch{}if(!(n instanceof Date)){let r=/(\d\d\d\d)-(\d\d)-(\d\d)/.exec(t);r&&(n=new Date(+r[1],+r[2]-1,+r[3],12,0));}if(n instanceof Date)return n}}}var{encode:Vt,decode:gr}=V(62),{encode:qt,decode:mr}=V(32),be=16;function je(){return Z(be)}function yr(e=je()){return Vt(e,22)}function hr(e){return Vt(e,22)}function xr(e){return gr(e,be)}function br(e=je()){return qt(e,26)}function Tr(e){return qt(e,26)}function wr(e){return mr(e,be)}var Lr="10000000-1000-4000-8000-100000000000",vr=typeof crypto<"u"&&crypto.randomUUID!=null?crypto.randomUUID.bind(crypto):()=>Lr.replace(/[018]/g,e=>(e^Z(1)[0]&15>>e/4).toString(16));function Ar(e){let t=at(e);return `${t.slice(0,8)}-${t.slice(8,12)}-${t.slice(12,16)}-${t.slice(16)}`}function Er(e){return ut(e.replaceAll("-",""))}var Wt=16e11;function Pr(e){let t=new Uint8Array([0,0,0,0,0,0]),n=t.length-1;for(let r=0;r<t.length;r++){let o=e&255;t[n-r]=o,e=(e-o)/256;}return t}function Jt(){let e=se()-Wt;return new Uint8Array([...Pr(e),...Z(10)])}function vu(){return Dr(Jt())}function Au(e){return Sr(Kt(e))}function Sr(e){return new Date(Wt+e.slice(0,6).reduce((t,n)=>t*256+n,0))}var Eu=()=>new Uint32Array(Z(4))[0],Ne={base62:{uuid:yr,uuidDecode:xr,uuidEncode:hr},base32:{uuid:br,uuidDecode:wr,uuidEncode:Tr},uuidv4:{uuid:vr,uuidDecode:Er,uuidEncode:Ar}},Te="base62",Zt=!1;function Pu(e,t=!1){Te=e,Zt=t;}function q(){return Ne[Te].uuid(Zt?Jt():je())}function Kt(e){return Ne[Te].uuidDecode(e)}function Dr(e){return Ne[Te].uuidEncode(e)}function Su(e){try{return Kt(e).length===be}catch{}return !1}var _e={};function $(e="id"){return _e[e]==null&&(_e[e]=0),`${e}-${_e[e]++}`}var Ur=0;function Du(){return `id-${Ur++}`}var He=class extends k{constructor(){super(...arguments);this.id=q();}close(){this.dispose();}},we=class extends He{constructor(){super(...arguments);this.isConnected=!0;}postMessage(n){this.other?.emit("message",{data:n,origin:"local",lastEventId:q()});}};function Fu(){let e=new we,t=new we;return e.other=t,t.other=e,[e,t]}var Yt=class{async encode(t){return t}async decode(t){return t}},ee=class{async encode(t){return Pe(t)}async decode(t){return Se(t)}},Qt=class{constructor(t){this.key=t;}async encode(t){let n=Pe(t);return await gt(n,this.key)}async decode(t){let n=await mt(t,this.key);return Se(n)}};var Xt=(e,t,n={})=>new Proxy(n,{get:(r,o)=>o in r?r[o]:(...i)=>e(o,i,t)});function Hu(e={}){let{name:t=$("hub"),encoder:n=new ee,retryAfter:r=1e3,ignoreUnhandled:o=!0,logLevel:i=!1}=e,a=w(t,i),s={},u,c=[],d,l={},f=()=>{clearTimeout(d);},p=async()=>{if(clearTimeout(d),u){if(u.isConnected)for(;c.length;){let y=c[0];try{u.postMessage(await n.encode(y)),c.shift();}catch(L){a.warn("postMessage",L);break}}c.length>0&&r>0&&(d=setTimeout(p,r));}},g=async y=>{a("enqueue postMessage",y),c.push(y),await p();},m=async y=>{u=y,u.on("connect",p),u.on("message",async L=>{a("onmessage",typeof L);let{name:E,args:S,id:h,result:x,error:v}=await n.decode(L.data);if(E){a(`name ${E} id ${h}`);try{if(s[E]==null)throw new Error(`handler for ${E} was not found`);let P=s[E](...S);C(P)&&(P=await P),a(`result ${P}`),h&&await g({id:h,result:P});}catch(P){let T=P instanceof Error?P:new Error(ke(P));a.warn("execution error",T.name),await g({id:h,error:{message:T.message,stack:T.stack,name:T.name}});}}else if(h)if(a(`response for id=${h}: result=${x}, error=${v}`),l[h]==null)x===void 0?a(`skip response for ${h}`):a.warn(`no response hook for ${h}`);else {let[P,T]=l[h];if(P&&T)if(delete l[h],v){let D=new Error(v.message);D.stack=v.stack,D.name=v.name,a.warn("reject",D.name),T(D);}else a("resolve",x),P(x);}else o||a.warn("Unhandled message",L);}),await p();},b=async(y,L,E={})=>{let{timeout:S=5e3}=E,h=q();return await g({name:y,args:L,id:h}),Dt(new Promise((x,v)=>l[h]=[x,v]),S)};return e.channel&&m(e.channel),{dispose:f,connect:m,listen(y){Object.assign(s,y);},send(){return Xt(b,{},{options(y){return Xt(b,{...y})}})}}}var ze=class extends k{constructor(n){super();this.publish=this.emit.bind(this);this.subscribe=this.on.bind(this);let{name:r,encoder:o=new ee,channel:i,debug:a=!1}=n;this.channel=i,this.encoder=o,this.debug=a,this.name=r??this.channel.id??$("pubsub"),this.log=w(`${this.shortId}`),this.debug&&(this.channel.on("connect",()=>{this.log("channel connected");}),this.channel.on("disconnect",()=>{this.log("channel disconnected");})),this.channel.on("message",async({data:s})=>{let u=await this.encoder.decode(s);if(this.debug?this.log(`channel message, event=${u?.event}, info=`,u):this.log(`channel message, event=${u?.event}`),u){let{event:c,args:d}=u;await this.emitSuper(c,...d);}});}get shortId(){return this.name.substr(0,6)}async emitSuper(n,...r){return await super.emit(n,...r)}async emit(n,...r){try{if(this.debug?this.log(`emit(${String(n)})`,n):this.log(`emit(${String(n)})`,r.length),!this.channel.isConnected)return this.log.warn("channel not connected"),!1;let o=await this.encoder.encode({event:n,args:r});return this.channel.postMessage(o),!0}catch(o){this.log.warn(`emit(${String(n)})`,o);}return !1}};function Ju(e){return new ze(e)}var Rr=1;var en=e=>e,Mr=en;function Ku(e,t){let{post:n,on:r,eventNames:o=[],serialize:i=en,deserialize:a=Mr}=t,s=new Map;return r(async u=>{let c=a(u),[d,l,f,p]=c;if(d===1||d===2){let g,m;if(p!=null)try{let b=e[p];g=await b(...l);}catch(b){m=String(b);}else m="Method implementation missing";d===1&&f&&n(i(m?[4,m,f]:[3,g,f]));}else if(f){let g=s.get(f);g!=null&&(d===4?g.reject(l):g.resolve(l)),s.delete(f);}}),new Proxy({},{get(u,c){let d=(...f)=>{n(i([2,f,null,c]));};if(t.onlyEvents||o.includes(c))return d.asEvent=d,d;let l=(...f)=>new Promise((p,g)=>{let m=Rr++;s.set(m,{resolve:p,reject:g}),n(i([1,f,m,c]));});return l.asEvent=d,l}})}var W=class extends k{constructor(n={}){super();this._isCancelled=!1;this._resetWhenFinished=!0;this._children=[];this._totalUnits=n.totalUnits??0,this._completedUnits=n.completeUnits??0,this._resetWhenFinished=n.resetWhenFinished??!0,this.name=n.name??$("progress"),this.dispose.add(async()=>{for(let r of this._children)await r.dispose();await this.emit("progressDispose",this);});}update(){this.emit("progressChanged",this),this._isCancelled&&this._resetWhenFinished&&this.getTotalUnits()<=this.getCompletedUnits()&&this.reset();}reset(){if(this._isCancelled){this._isCancelled=!1;for(let n of this._children)n.reset();this.update();}}async cancel(){if(!this._isCancelled){this._isCancelled=!0,await this.emit("progressCancelled",this);for(let n of this._children)await n.cancel();this.update();}}addChild(n){n.on("progressDispose",()=>this.removeChild(n)),n.on("progressChanged",()=>this.update()),this._children.includes(n)||this._children.push(n),this.update();}createChildProgress(n){let r=new W(n);return this.addChild(r),r}removeChild(n){yt(this._children,n),this.update();}getTotalUnits(){if(this.isIndeterminate())return 0;let n=this._totalUnits;for(let r of this._children)n+=r.getTotalUnits();return n}getCompletedUnits(){if(this.isIndeterminate())return 0;let n=this._completedUnits;for(let r of this._children)n+=r.getCompletedUnits();return n}isIndeterminate(){return this._totalUnits<=0&&this._children.length<=0}isCancelled(){return this._isCancelled}isFinished(){return this.dispose.isDisposed()||!this.isIndeterminate()&&this.getTotalUnits()<=this.getCompletedUnits()}getFraction(){if(this.isIndeterminate())return 0;let n=this.getCompletedUnits()/this.getTotalUnits();return isNaN(n)&&(n=0),Math.min(1,Math.max(0,n))}getChildrenCount(){return this._children.length}setTotalUnits(n,r){this._totalUnits=n,r!=null&&(this._completedUnits=r),this.update();}incTotalUnits(n=1){this._totalUnits+=n,this.update();}setCompletetedUnits(n){this._completedUnits=n,this.update();}setCompleted(){this._completedUnits=this._totalUnits,this.update();}incCompletedUnits(n=1){this._completedUnits+=n,this.update();}toString(n=0){let r=`${"  ".repeat(n)}${this.name}: ${this._completedUnits} of ${this._totalUnits} units, ${Math.floor(this.getFraction()*100)} %, cancel=${this._isCancelled}
`;for(let o of this._children)r+=o.toString(n+1);return n===0?r.trim():r}};var Fr=(o=>(o[o.replace=0]="replace",o[o.memoize=1]="memoize",o[o.prioritize=2]="prioritize",o[o.error=3]="error",o))(Fr||{}),kr=(r=>(r[r.waiting=0]="waiting",r[r.running=1]="running",r[r.finished=2]="finished",r))(kr||{});function gc(e={}){let{maxParallel:t=3,name:n=$("pool"),idConflictResolution:r=1}=e,o=new k,i=ie();i.add(L);let a=new W({name:n});a.on("progressCancelled",L);let s=0,u=0,c=0,d=0,l={};async function f(){if(s>0){let[h,x]=Et();return o.once("didFinish",x),h}}async function p(){for(let h of Object.keys(l))l[h].state===2&&(await l[h].progress.dispose(),delete l[h]);}function g(){o.emit("didFinish"),s=0,u=0,p(),a.reset();}function m(){let h=0,x=0;for(let{max:v,resolved:P,state:T}of Object.values(l))h+=v,x+=T===2?v:Math.min(v,P);o.emit("didUpdate",s,u,h,x);}function b(){if(m(),s>0&&s===u&&g(),c>=t)return;let h=Object.values(l).filter(x=>x.state===0);if(h.length>0){let x;for(let v of h)v.group!=null&&Object.values(l).some(P=>P.state===1&&P.id!==v.id&&P.group===v.group)||(x==null||v.priority<x.priority)&&(x=v);if(x!=null){let v=x.id,P=x.done;x.state=1,++c,o.emit("didStart",v);let T=D=>{x&&(x.result=D,x.state=2,x.resolved=x.max,x.progress?.setCompleted()),--c,++u,b();};x.task(x).then(D=>{P(D),o.emit("didResolve",v,D),T(D);}).catch(D=>{P(),o.emit("didReject",v,D),T();});}}}function y(h){let x=l[h];x&&x.state===0&&(l[h].state=2,++u,o.emit("didCancel",h),l[h].progress.dispose(),m());}function L(){Object.keys(l).forEach(y);}function E(h){return l[h]!=null}function S(h,x={}){let v,P=new Promise(R=>v=R),T=x.id??q();if(l[T]!=null){let R=x.idConflictResolution??r;if(R===0)y(T);else if(R===1||R===2){let et=l[T];return R===2&&(et.priority=++d),{id:T,promise:(async()=>{if(et.state===2)return l[T].result})(),dispose:()=>y(T),cancel:()=>y(T)}}else throw new Error(`Pool task with id=${T} already exists!`)}let D=new W({name:T,totalUnits:x.max??1,completeUnits:x.resolved??0});return a.addChild(D),l[T]={id:T,task:h,priority:++d,group:x.group,state:0,max:x.max??1,resolved:x.resolved??0,done:v,payload:x.payload,progress:D,setMax(R){D.setTotalUnits(R),l[T].max=R,m();},setResolved(R){D.setCompletetedUnits(R),l[T].resolved=R,m();},incResolved(R=1){D.incCompletedUnits(R),l[T].resolved+=R,m();}},++s,b(),{id:T,promise:P,dispose:()=>y(T),cancel:()=>y(T)}}return {events:o,cancel:y,cancelAll:L,hasById:E,progress:a,enqueue:S,dispose:i,waitFinishAll:f}}var tn=class extends k{constructor(n={}){super();this.queue=[];this.waitToFinish=[];this.countMax=0;this.countResolved=0;this.paused=!1;let{name:r=$("queue"),logLevel:o}=n;this.name=r,this.log=w(`zeed:queue:${r}`,o??1/0);}async performNext(){if(this.log("performNext, queue.length =",this.queue.length),this.currentTask!=null){this.log("performNext => skip while another task is running");return}if(this.paused){this.log("performNext => skip while is paused");return}for(;this.currentTask==null&&!this.paused;){let n=this.queue.shift();if(this.log(`performNext => ${n?.name}`),n==null)break;this.countResolved===0&&this.emit("didStart",this.countMax);let{name:r,task:o,resolve:i}=n;this.currentTask=o();let a;try{this.log.info(`start task ${r}`),a=await this.currentTask,this.log(`finished task ${r} with result =`,a);}catch(s){this.log.warn("Error performing task",s);}i(a),this.currentTask=void 0,this.countResolved+=1,this.emit("didUpdate",this.countMax,this.countResolved);}for(this.queue.length===0&&(this.emit("didFinish"),this.countMax=0,this.countResolved=0);this.waitToFinish.length>0;)this.waitToFinish.shift()();}async enqueue(n,r={}){let{immediate:o=!1,name:i=$(this.name)}=r;return o?(this.log.info(`immediate execution ${i}`),await n()):(this.log(`enqueue ${i}`),new Promise(a=>{this.queue.push({name:i,task:n,resolve:a}),this.countMax+=1,this.emit("didUpdate",this.countMax,this.countResolved),this.performNext();}))}async enqueueReentrant(n,r={}){return this.enqueue(n,{immediate:this.currentTask!=null,name:r.name})}async cancelAll(n=!0){this.log("cancelAll"),this.emit("didCancel");let r=this.queue.map(o=>o.resolve);this.queue=[],r.forEach(o=>o(void 0)),await this.wait();}async pause(){this.log("pause"),this.paused=!0,await this.wait();}resume(){this.log("resume"),this.paused=!1,this.performNext();}async wait(){if(this.log("wait"),!(this.currentTask==null&&(this.queue.length===0||this.paused)))return new Promise(n=>{this.waitToFinish.push(n);})}get isPaused(){return this.paused}get hasTasks(){return this.queue.length!==0}};var I=()=>{};function vc(e,t={}){let{delay:n=100,trailing:r=!0,leading:o=!0}=t,i=0,a=0,s=0,u,c=Date.now();function d(){return i?(clearTimeout(i),i=void 0,!0):!1}function l(...f){let p=Date.now(),g=p-a;function m(){let y=Date.now();return `total ${(y-c).toFixed(1)}ms - elapsed ${(y-a).toFixed(1)}ms - visited ${s}x`}let b=()=>{s=0,a=Date.now(),e.apply(this,f);};if(u=b,g>n||!i){o&&(g>n?(b()):++s);let y=g>n?n:n-g;I(`\u23F1 start timeout with ${y.toFixed(1)}ms`,m()),d(),a=p,i=setTimeout(()=>{i=0,r&&(!o||s>0)&&(u?.());},y);}else ++s;}return l.cancel=d,l.stop=()=>{d()&&u&&u();},l.immediate=async function(...p){d(),a=Date.now(),e.apply(this,p);},l.dispose=()=>l.stop(),l}function Ac(e,t={}){let{delay:n=100}=t,r=0,o=!1,i;function a(){r&&(clearTimeout(r),r=0);}async function s(){try{if(a(),i!=null){I("exec");let d=[...i];i=void 0,o=!0,await B(e(...d)),o=!1,I("exec done"),i!=null&&(a(),I("exec trigger next"),r=setTimeout(s,n));}}catch{}}function u(...d){i=[...d],a(),o===!1&&(r=setTimeout(s,n));}async function c(...d){a(),i=[...d],await s();}return u.cancel=a,u.dispose=a,u.immediate=c,u}function kc(e=globalThis?.location?.hostname??""){return ["::ffff:127.0.0.1","localhost","127.0.0.1","","::1","::"].includes(e)||e.startsWith("192.168.")||e.startsWith("10.0.")||e.endsWith(".local")}function Ic(e){let{level:t=void 0,filter:n=void 0,messages:r=[]}=e,o=O(n),i=N(t);return a=>{i(a.level)&&o(a.name)&&r.push(a);}}var ne=w("zeed:network","error"),Ge={cache:"no-cache",redirect:"follow",headers:{}};function Cr(e){let t=/:\/\/([^@]*)@/gi.exec(e);if(t&&t[1]){let[n,r]=t[1].split(":",2);return {url:e.replace(`${t[1]}@`,""),username:n,password:r}}}async function nn(e,t={},n=fetch){try{j(t)&&(t=xe({},...K(t)));let r=Cr(String(e));r&&(e=r.url,t=xe({},t,$r(r.username,r.password))),t.headers!=null&&!(t.headers instanceof Headers)&&(t.headers=new Headers(t.headers));let o=await n(String(e),t);if(o.status<400)return o;try{ne.warn(`Fetch of ${String(e)} returned status=${o.status}. Options:`,t),ne.warn(`Response: ${await o.text()}`);}catch(i){ne.error("Exception:",i);}}catch(r){ne.error("fetchBasic",r);}}async function Nc(e,t={},n=fetch){try{let r=await nn(e,[{method:"GET",headers:{Accept:"application/json"}},t],n);if(r)return await r.json()}catch(r){ne.error("fetchJSON error:",r);}}async function Hc(e,t={},n=fetch){try{let r=await nn(e,[Ge,{method:"GET"},t],n);if(r)return await r.text()}catch(r){ne.error("fetchHTML error:",r);}}function zc(e,t="POST"){return {method:t,...Ge,headers:{"Content-Type":"application/x-www-form-urlencoded; charset=utf-8"},body:Nt(e)}}function Gc(e,t="POST"){return {method:t,...Ge,headers:{"Content-Type":"application/json; charset=utf-8"},body:M(e)}}function $r(e,t){return {headers:{Authorization:`Basic ${ct(`${e}:${t}`)}`}}}function rn(){if(typeof window<"u")return window}function Ir(){if(typeof navigator<"u")return navigator}function qc(){return rn()??typeof WorkerGlobalScope<"u"?self:typeof global<"u"?global:Function("return this;")()}var z=Ir(),J=rn();function Or(e={ios:!1,macos:!1,windows:!1,beaker:!1,electron:!1,wkwebview:!1,pwa:!1,pwaInstalled:!1,browser:!1,node:!1,worker:!1,test:!1,jest:!1,macosNative:!1,iosNative:!1,appleNative:!1,touch:!1}){return e.ios=z?.platform?.match(/(iPhone|iPod|iPad)/i)!=null,e.macos=!!z?.platform?.startsWith("Mac"),e.windows=!!z?.platform?.startsWith("Win"),e.beaker=J?.beaker!=null,e.electron=(z?.userAgent?.toLowerCase()?.indexOf(" electron/")||-1)>-1&&!e.beaker,e.wkwebview=J?.webkit?.messageHandlers!=null,e.pwa=z?.serviceWorker!=null,e.pwaInstalled=z?.standalone||J?.matchMedia?.("(display-mode: standalone)")?.matches,e.node=typeof process<"u"&&process?.release?.name==="node",e.browser=!e.electron&&!e.wkwebview&&!e.node,e.worker=typeof WorkerGlobalScope<"u"&&self instanceof WorkerGlobalScope,e.jest=typeof jest<"u"||typeof vitest<"u",e.test=e.jest,e.macosNative=e.wkwebview&&e.macos,e.iosNative=e.wkwebview&&e.ios,e.appleNative=e.wkwebview,e.touch=J&&"ontouchstart"in J||(z?.maxTouchPoints||0)>1||z?.msPointerEnabled&&J?.MSGesture||J?.DocumentTouch&&document instanceof DocumentTouch,e}var Br=()=>typeof window<"u"&&globalThis===window,Wc=Or();function Jc(e){Br()?window.addEventListener("beforeunload",e):typeof process<"u"&&process.on("exit",()=>e);}var on=class{constructor(t={}){this.store={};}setItem(t,n){this.store[t]=Q(n);}getItem(t){return Q(this.store[t])}removeItem(t){delete this.store[t];}clear(){this.store={};}allKeys(){return Object.keys(this.store)}};var el=()=>{};function Al(e={}){let{args:t=process.argv.slice(1),alias:n={},normalize:r=xt,booleanArgs:o=[],listArgs:i=[],numberArgs:a=[]}=e,s=Object.entries(n).reduce((f,p)=>{let[g,m]=p;typeof m=="string"&&(m=[m]);for(let b of m)f[r(b)]=r(g);return f},{}),u={_:[]};function c(f,p){u[f]==null||typeof u[f]=="boolean"?u[f]=p:Array.isArray(u[f])?u[f].push(p):u[f]=[u[f],p];}let d=[...t],l;for(;l=d.shift();){let f;if(/^--?/.test(l)){let p=l.replace(/^--?/,"");if(l.includes("=")){let[g,m]=p.split("=",2);p=g.trim(),f=m.trim();}p=r(p),p=s[p]??p,o.includes(p)?c(p,!0):(f=f??d.shift()??"",a.includes(p)&&(f=Number(f??0)),i.includes(p)?Array.isArray(u[p])?u[p].push(f):u[p]=[f]:c(p,f));}else u._.push(l);}return u}function Pl(e){return new Promise((t,n)=>{import('child_process').then(({spawn:r})=>{let o=r("pbcopy");o.on("error",i=>n(i)),o.on("close",()=>t(e)),o.stdin.write(e),o.stdin.end();}).catch(()=>{});})}try{typeof globalThis<"u"&&typeof globalThis.crypto>"u"&&Ve__default.default&&Ve__default.default.webcrypto&&(globalThis.crypto=Ve__default.default.webcrypto);}catch(e){console.warn("Failed to polyfill webcrypto",e);}var ae=w("zeed:env","error"),jr=`
`,Nr=/^\s*([\w_.-]+)\s*=\s*(.*)?\s*$/,Hr=/\\n/g,zr=/\n|\r|\r\n/;function sn(e,t={}){let n={};return String(e).split(zr).forEach((r,o)=>{let i=r.match(Nr);if(i!=null){let a=i[1],s=i[2]||"",u=s.length-1,c=s[0]==='"'&&s[u]==='"';s[0]==="'"&&s[u]==="'"||c?(s=s.substring(1,u),c&&(s=s.replace(Hr,jr))):s=s.trim(),n[a]=s;}else ae.debug(`did not match key and value when parsing line ${o+1}: ${r}`);}),n}function Gr(e,t="."){return path.resolve(process.cwd(),e??t)}function Vr(e,t=""){return e==null&&(e=t),Gr(String(e).trim(),t)}var qe=Vr;function kl(e,t=process.env){if(t[e]!=null)return t[e];e=e.toLowerCase();for(let[n,r]of Object.entries(t))if(n.toLowerCase()===e)return r}function Cl(e={}){let t=e?.path??qe(e?.filename??".env"),n=e?.encoding??"utf8",r=e?.debug||!1;r!==!0&&(ae.level=1/0);try{let o=Le__default.default.existsSync(t)?sn(Le__default.default.readFileSync(t,{encoding:n}),{debug:r}):{},i=Le__default.default.existsSync(`${t}.local`)?sn(Le__default.default.readFileSync(`${t}.local`,{encoding:n}),{debug:r}):{},a=Object.assign({},o,i),s=e?.env??process.env;return Object.entries(a).forEach(([u,c])=>{typeof e?.prefix=="string"&&(u=e?.prefix+u),Object.prototype.hasOwnProperty.call(s,u)?ae.debug(`"${u}" is already defined and will not be overwritten`):c!=null&&(ae.info(`set env.${u} = ${c}`),s[u]=c);}),{parsed:a}}catch(o){return ae.error(o),{error:o}}}var cn=w("zeed:filestorage","error"),ln=class{constructor(t={}){this.store={};this.fileKeys=void 0;this.pretty=!1;this.dirname=path.resolve(process.cwd(),t.path??".fileStorage"),this.pretty=!!t.pretty,this.extension=t.extension??".json",t.extension&&!this.extension.startsWith(".")&&(this.extension=`.${this.extension}`),this.extensionLength=this.extension.length,this.objectToString=t.objectToString??(n=>this.pretty?M(n,null,2):M(n)),this.objectFromString=t.objectFromString??(n=>{try{return JSON.parse(n)}catch(r){cn.warn(`fileStorage parse error '${r}' in`,n);}}),this.keyToFilename=t.keyToFilename??It;}setItem(t,n){this.store[t]=Q(n);try{let r=this.objectToString(n),o=this.getPath(t);Le.mkdirSync(path.dirname(o),{recursive:!0}),Le.writeFileSync(o,r,"utf8");}catch(r){cn.error("setItem error",r);}}getPath(t){return path.resolve(this.dirname,this.keyToFilename(t)+this.extension)}getBuffer(t){let n=this.getPath(t);return Buffer.from(Le.readFileSync(n))}getItem(t){let n=this.store[t];if(n!==null){if(n!=null)return Q(n);try{let r=this.getPath(t),o=Le.readFileSync(r,"utf8");if(o!=null){let i=this.objectFromString(o);return this.store[t]=i,i}}catch{this.store[t]=null;}}}removeItem(t){if(delete this.store[t],this.fileKeys!=null){let n=this.fileKeys.indexOf(t);n!==-1&&this.fileKeys.splice(n,1);}try{let n=this.getPath(t);Le.unlinkSync(n);}catch{}}clear(){this.fileKeys=[],this.store={},Le.rmSync(this.dirname,{recursive:!0,force:!0});}allKeys(){if(this.fileKeys==null)try{this.fileKeys=Le.readdirSync(this.dirname,{withFileTypes:!0}).filter(n=>!n.isDirectory()&&n.name.endsWith(this.extension)).map(n=>n.name.slice(0,-this.extensionLength))||[];}catch{}let t=[...this.fileKeys||[]];for(let n of Object.keys(this.store))t.includes(n)||t.push(n);return t.sort(),t}};function Vl(e){let t=path.normalize(e),n=process.env.HOME;return n&&t.startsWith(n)?`~${t.slice(n.length)}`:t}async function Je(e){try{await promises.stat(e);}catch{return !1}return !0}async function ql(...e){let t=path.join(...e);return await Je(t)||await promises.mkdir(t,{recursive:!0}),t}async function Wl(...e){let t=path.join(...e);return await Je(t)&&await promises.rm(t,{recursive:!0}),t}async function Jl(...e){let t=path.join(...e);if(await Je(t))return await promises.readFile(t,"utf-8")}async function Zl(e,t){await promises.writeFile(e,t,"utf-8");}var fn={};function dn(e,t={}){let{level:n=void 0,filter:r=void 0,time:o=!0,pretty:i=!1}=t;e=path.resolve(process.cwd(),e),Le.mkdirSync(path.dirname(e),{recursive:!0});let a=Le.createWriteStream(e,{flags:"a"}),s=O(r),u=N(n);return c=>{if(!u(c.level)||!s(c.name))return;let d=o?`${new Date().toISOString()} `:"",l=c.name||"",f=fn[l||""];f==null&&(fn[l]=f);let p=[`[${l||"*"}]`,ge(c.messages,{pretty:i})];function g(...m){a.write(`${m.join("	")}
`);}switch(c.level){case 1:g(`${d}I|*  `,...p);break;case 2:g(`${d}W|** `,...p);break;case 3:g(`${d}E|***`,...p);break;default:g(`${d}D|   `,...p);break}}}function uo(e){return typeof e!="string"?[]:e?.split(`
`).map(t=>{let n=t.match(/^\s+at.*(\((.*)\)|file:\/\/(.*)$)|\s*at\s(\/.*)$/);if(n){let r=n[3]||n[2]||n[4];return r.endsWith(")")&&(r=r.slice(0,-1)),r}})?.filter(Ft)??[]}var Ze=path.resolve(process.cwd()),Ke=process.env?.HOME?path.resolve(process.env?.HOME):"";function gn(e){if(e.includes("/node_modules/"))return "";let t="file://";return e.startsWith(t)?e.substr(t.length):Ze&&e.startsWith(Ze)?e.substr(Ze.length+1):(Ke&&e.startsWith(Ke)&&(e=`~/${e.substr(Ke.length+1)}`),e)}function co(e){let t=e.match(/^\s*at.*(\((.*)\)|file:\/\/(.*)$)|\s*at\s(\/.*)$/);if(t){let n=t[3]||t[2]||t[4];return n.endsWith(")")&&(n=n.slice(0,-1)),n}return ""}function Ye(e=2,t=!0){let n=new Error("stack").stack||"",r=uo(n)?.[e];return r&&t&&(r=gn(r)),r||""}function mn(){return new Error("stack").stack||""}function yn(e,t=!0){let n="",r=new Error("stack").stack||"";if(typeof r=="string"){let o=r.split(`
`).map(a=>a.trim()),i=o.findIndex(a=>e.some(s=>a.startsWith(s)));n=o[i+1],n&&(n=co(n)),n&&t&&(n=gn(n));}return n}function fo(){try{return Y(process.env.ZEED_COLOR,lo__default.default.isatty(process.stdout.fd))}catch{}return !1}var Qe,hn=[6,2,3,4,5,1];function po(e){let t=0;for(let n=0;n<e.length;n++)t=(t<<5)-t+e.charCodeAt(n),t|=0;return hn[Math.abs(t)%hn.length]}var xn={},Xe;function ve(...e){process.stdout.write(`${ge(e)}
`);}var ce={BOLD:"\x1B[1m",UNBOLD:"\x1B[2m",RED:"\x1B[31m",GREEN:"\x1B[32m",BLUE:"\x1B[34m",PURPLE:"\x1B[35m",GRAY:"\x1B[37m",ORANGE:"\x1B[38;5;208m",UNCOLOR:"\x1B[0m"};var Tn="\x1B[0m";function ue(e,t){return `${t===8?ce.ORANGE:`\x1B[3${t<8?t:`8;5;${t}`}m`}${e}${Tn}`}function bn(e,t,n=!0){return e.map(r=>{if(typeof r!="string")return r;let o=t,i=Tn;return n&&(o=`${ce.BOLD}${o}`,i=`${i}${ce.BOLD}`),`${o}${r}${i}`})}var go="loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";function wn(e={}){Qe==null&&(Qe=fo()),Xe==null&&(Xe=se());let{level:t=void 0,filter:n=void 0,colors:r=Qe,levelHelper:o=!0,nameBrackets:i=!0,padding:a=0,fill:s=0,stack:u=!0,time:c=!0}=e,d=O(n),l=N(t);return f=>{if(!l(f.level)||!d(f.name))return;let p=se(),g=f.name||"",m=xn[g||""];m==null&&(m={color:po(g)},xn[g]=m);let b=Gt(p-Xe),y,L=i?`[${g}]`:g;if(a>0&&(L=L.padStart(a," ")),s>0&&(L=L.padEnd(s," ")),r){let h=m.color;y=[`${ue(L,h)} | `],f.level===2?y.push(...bn(f.messages,ce.ORANGE)):f.level===3?y.push(...bn(f.messages,ce.RED)):y.push(...f.messages),c&&y.push(ue(`+${b}`,h));}else y=[L,...f.messages],c&&y.push(`+${b}`);if(f.messages?.[0]===go&&console.log(mn()),u){let h="";typeof u=="boolean"?(h=yn(["at Function.","at null.log (","at log ("],!0),h||(h=Ye(0,!0))):h=Ye(typeof u=="number"?u:3,!0),h&&y.push(ue(`(${h})`,7));}let E="|",S=".";switch(f.level){case 1:o&&(y[0]=`I${E}${S}   ${y[0]}`),ve(...y);break;case 2:o&&(y[0]=(r?ue(`W${E}${S}${S}  `,8):`W${E}${S}${S}  `)+y[0]),ve(...y);break;case 3:o&&(y[0]=(r?ue(`E${E}${S}${S}${S} `,1):`E${E}${S}${S}${S} `)+y[0]),ve(...y);break;default:o&&(y[0]=`D${E}    ${y[0]}`),ve(...y);break}}}function mo(){let e=[wn({padding:32,nameBrackets:!1})],t=process.env.ZEED_LOG??process.env.LOG,n=Y(process.env.ZEED_TIME,!0),r=Y(process.env.ZEED_PRETTY,!1);t&&e.unshift(dn(qe(t),{time:n,pretty:r})),w.setHandlers(e);}mo();

exports.CRYPTO_DEFAULT_ALG = De;
exports.CRYPTO_DEFAULT_DERIVE_ALG = dt;
exports.CRYPTO_DEFAULT_DERIVE_ITERATIONS = Mn;
exports.CRYPTO_DEFAULT_HASH_ALG = pt;
exports.Channel = He;
exports.CryptoEncoder = Qt;
exports.DAY_MS = $e;
exports.Day = A;
exports.Emitter = k;
exports.FileStorage = ln;
exports.JsonEncoder = ee;
exports.LocalChannel = we;
exports.LogLevel = H;
exports.LogLevelAlias = tt;
exports.Logger = w;
exports.LoggerConsoleHandler = le;
exports.LoggerContext = nt;
exports.LoggerFileHandler = dn;
exports.LoggerMemoryHandler = Ic;
exports.LoggerNodeHandler = wn;
exports.MemStorage = on;
exports.NoopEncoder = Yt;
exports.PoolTaskIdConflictResolution = Fr;
exports.PoolTaskState = kr;
exports.Progress = W;
exports.PubSub = ze;
exports.SerialQueue = tn;
exports.Uint8ArrayToHexDump = ft;
exports.Uint8ArrayToJson = Se;
exports.Uint8ArrayToString = st;
exports.XRX = zt;
exports._decodeUtf8Polyfill = Un;
exports._encodeUtf8Polyfill = Dn;
exports.arrayAvg = pi;
exports.arrayBatches = gi;
exports.arrayEmptyInPlace = ii;
exports.arrayFilterInPlace = Fe;
exports.arrayFlatten = K;
exports.arrayIntersection = On;
exports.arrayIsEqual = _n;
exports.arrayMax = li;
exports.arrayMin = fi;
exports.arrayMinus = $n;
exports.arrayRandomElement = ci;
exports.arrayRemoveElement = yt;
exports.arraySetElement = ri;
exports.arrayShuffle = ai;
exports.arrayShuffleForce = ui;
exports.arrayShuffleInPlace = ht;
exports.arraySorted = Bn;
exports.arraySortedNumbers = si;
exports.arraySum = di;
exports.arraySymmetricDifference = ni;
exports.arrayToggleInPlace = oi;
exports.arrayUnion = In;
exports.arrayUnique = Me;
exports.avg = qo;
exports.between = Vo;
exports.cloneJsonObject = fa;
exports.cloneObject = Q;
exports.cmp = Re;
exports.colorString = ue;
exports.colorStringList = bn;
exports.composeOrderby = Yo;
exports.createArray = mi;
exports.createLocalChannelPair = Fu;
exports.createPromise = Et;
exports.createPromiseProxy = Xt;
exports.csvParse = fr;
exports.csvParseToObjects = qa;
exports.csvStringify = Va;
exports.dateStringToDays = ls;
exports.day = cs;
exports.dayDay = Wn;
exports.dayDiff = Ji;
exports.dayFromAny = zi;
exports.dayFromDate = ye;
exports.dayFromDateGMT = Vi;
exports.dayFromParts = Oe;
exports.dayFromString = vt;
exports.dayFromTimestamp = Jn;
exports.dayFromToday = Lt;
exports.dayIterator = Ki;
exports.dayMonth = Tt;
exports.dayMonthStart = qi;
exports.dayOffset = me;
exports.dayRange = Zi;
exports.dayToDate = wt;
exports.dayToDateGMT = Gi;
exports.dayToParts = Hi;
exports.dayToString = Zn;
exports.dayToTimestamp = Ce;
exports.dayYear = Ie;
exports.dayYearStart = Wi;
exports.debounce = Ac;
exports.decimal = Kn;
exports.decimalCentsPart = gs;
exports.decimalFromCents = ds;
exports.decimalToCents = ps;
exports.decodeBase16 = Li;
exports.decodeBase32 = Ti;
exports.decodeBase58 = Ai;
exports.decodeBase62 = Pi;
exports.decrypt = mt;
exports.deepEqual = Yn;
exports.deepMerge = xe;
exports.deepStripUndefinedInPlace = Qn;
exports.deriveKeyPbkdf2 = jo;
exports.detect = Or;
exports.digest = _o;
exports.empty = la;
exports.encodeBase16 = wi;
exports.encodeBase32 = bi;
exports.encodeBase58 = vi;
exports.encodeBase62 = Ei;
exports.encodeQuery = Nt;
exports.encrypt = gt;
exports.endSortWeight = jt;
exports.ensureFolder = ql;
exports.ensureKey = sa;
exports.ensureKeyAsync = aa;
exports.equalBinary = lt;
exports.escapeHTML = kt;
exports.escapeRegExp = Ot;
exports.estimateSizeForBase = Si;
exports.exists = Je;
exports.fetchBasic = nn;
exports.fetchJson = Nc;
exports.fetchOptionsBasicAuth = $r;
exports.fetchOptionsFormURLEncoded = zc;
exports.fetchOptionsJson = Gc;
exports.fetchText = Hc;
exports.fixBrokenUth8String = ji;
exports.forEachDay = as;
exports.forTimes = ga;
exports.formatMessages = qn;
exports.formatMilliseconds = Gt;
exports.fromBase64 = Rn;
exports.fromBase64String = Io;
exports.fromCamelCase = Ri;
exports.fromHex = ut;
exports.getEnvVariableRelaxed = kl;
exports.getGlobal = qc;
exports.getGlobalContext = re;
exports.getGlobalEmitter = pu;
exports.getGlobalLogger = Pn;
exports.getNamespaceFilterString = vn;
exports.getNavigator = Ir;
exports.getSecureRandom = Fn;
exports.getSecureRandomIfPossible = U;
exports.getSourceLocation = Ye;
exports.getSourceLocationByPrecedingPattern = yn;
exports.getStack = mn;
exports.getStackLlocationList = uo;
exports.getTimestamp = se;
exports.getWindow = rn;
exports.immediate = es;
exports.isArray = j;
exports.isBoolean = Mt;
exports.isBrowser = Br;
exports.isEven = Bt;
exports.isHalf = oe;
exports.isInteger = hs;
exports.isLocalHost = kc;
exports.isNotNull = Ft;
exports.isNull = Ts;
exports.isNullOrUndefined = bs;
exports.isNumber = Rt;
exports.isObject = _;
exports.isPrime = Jo;
exports.isPrimeRX = Wo;
exports.isPrimitive = Be;
exports.isPromise = C;
exports.isRecord = he;
exports.isRecordPlain = ys;
exports.isSafeInteger = xs;
exports.isString = Ut;
exports.isTimeout = ns;
exports.isUint8Array = ws;
exports.isValue = Ls;
exports.joinToUint8Array = Co;
exports.jsonStringify = Ro;
exports.jsonStringifySafe = M;
exports.jsonStringifySorted = Uo;
exports.jsonToUint8Array = Pe;
exports.last = ca;
exports.lazyListener = mu;
exports.linkifyPlainText = na;
exports.listDistinctUnion = Rs;
exports.listGroupBy = Us;
exports.listOfKey = Ms;
exports.listQuery = Ds;
exports.loggerStackTraceDebug = go;
exports.memoize = da;
exports.memoizeAsync = pa;
exports.messages = gu;
exports.moveSortWeight = Ks;
exports.noop = el;
exports.objectIsEmpty = Is;
exports.objectMap = Cs;
exports.objectMergeDisposable = $s;
exports.parseArgs = Al;
exports.parseBasicAuth = Cr;
exports.parseDate = hu;
exports.parseLogLevel = Ae;
exports.parseOrderby = Cn;
exports.parseQuery = ra;
exports.pbcopy = Pl;
exports.platform = Wc;
exports.promisify = B;
exports.qid = Du;
exports.randomBoolean = Ho;
exports.randomFloat = Go;
exports.randomInt = zo;
exports.randomUint8Array = Z;
exports.readText = Jl;
exports.regExpEscape = ha;
exports.regExpString = cr;
exports.removeFolder = Wl;
exports.renderMessages = ge;
exports.roundDown = Ns;
exports.roundHalfAwayFromZero = Gs;
exports.roundHalfDown = Vs;
exports.roundHalfEven = qs;
exports.roundHalfOdd = zs;
exports.roundHalfTowardsZero = Ws;
exports.roundHalfUp = Hs;
exports.roundUp = js;
exports.seededRandom = Zo;
exports.setUuidDefaultEncoding = Pu;
exports.setupEnv = Cl;
exports.size = ua;
exports.sleep = Xi;
exports.sortedItems = rr;
exports.sortedOrderby = Qo;
exports.startSortWeight = _t;
exports.stringToBoolean = ki;
exports.stringToFloat = $i;
exports.stringToInteger = Ci;
exports.stringToPath = Gr;
exports.stringToUInt8Array = it;
exports.suid = vu;
exports.suidBytes = Jt;
exports.suidBytesDate = Sr;
exports.suidDate = Au;
exports.sum = kn;
exports.throttle = vc;
exports.timeout = ts;
exports.timeoutReached = Pt;
exports.timoutError = St;
exports.toBase64 = ct;
exports.toBase64Url = $o;
exports.toBool = _i;
exports.toCamelCase = xt;
exports.toCapitalize = zn;
exports.toCapitalizeWords = Ui;
exports.toFloat = Ii;
exports.toHex = at;
exports.toHumanReadableFilePath = Vl;
exports.toHumanReadableUrl = ir;
exports.toInt = Oi;
exports.toPath = qe;
exports.toString = Bi;
exports.toUint8Array = F;
exports.toValidFilename = It;
exports.today = us;
exports.tryTimeout = Dt;
exports.uname = $;
exports.unescapeHTML = Ps;
exports.useAsyncMutex = su;
exports.useBase = V;
exports.useDefer = Xa;
exports.useDispose = ie;
exports.useDisposer = Qa;
exports.useEventListener = nu;
exports.useExitHandler = Jc;
exports.useInterval = tu;
exports.useLevelFilter = N;
exports.useMessageHub = Hu;
exports.useMutex = iu;
exports.useNamespaceFilter = O;
exports.usePool = gc;
exports.usePubSub = Ju;
exports.useRPC = Ku;
exports.useSorted = Xs;
exports.useTimeout = eu;
exports.uuid = q;
exports.uuid32bit = Eu;
exports.uuidB32 = br;
exports.uuidB62 = yr;
exports.uuidBytes = je;
exports.uuidDecode = Kt;
exports.uuidDecodeB32 = wr;
exports.uuidDecodeB62 = xr;
exports.uuidDecodeV4 = Er;
exports.uuidEncode = Dr;
exports.uuidEncodeB32 = Tr;
exports.uuidEncodeB62 = hr;
exports.uuidEncodeV4 = Ar;
exports.uuidIsValid = Su;
exports.uuidv4 = vr;
exports.valueToBoolean = Y;
exports.valueToFloat = Vn;
exports.valueToInteger = Gn;
exports.valueToPath = Vr;
exports.valueToString = ke;
exports.waitOn = rs;
exports.writeText = Zl;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=index.node.cjs.map